/**
 * HYPERLOOP GENERATED - DO NOT MODIFY
 *
 * This source code is Copyright (c) 2016 by Appcelerator, Inc.
 * All Rights Reserved.  This code contains patents and/or patents pending.
 */
#import <CoreGraphics/CoreGraphics.h>
#import "TiBase.h"
#import "KrollCallback.h"

@interface HyperloopPointer : NSObject
+(instancetype)pointer:(const void *)pointer encoding:(const char *)encoding;
+(instancetype)pointer:(const void *)pointer encoding:(const char *)encoding framework:(NSString *)framework classname:(NSString *)classname;
-(void *)pointerValue;
-(SEL)selectorValue;
-(Class)classValue;
-(id)objectValue;
@end

@interface HyperloopUtils : NSObject
+(void)invokeCallback:(id)callback args:(NSArray *)args thisObject:(id)thisObject;
@end

@interface HyperloopCoreGraphics : NSObject
@end

@implementation HyperloopCoreGraphics


+(id)CGAffineTransformMakeRotation:(NSArray *)args {
#ifdef TARGET_IPHONE_SIMULATOR
	if ([args count] != 1) {
		@throw [NSException exceptionWithName:@"InvalidArgument" reason:[NSString stringWithFormat:@"CGAffineTransformMakeRotation requires 1 arguments but only %lu passed", (unsigned long)[args count]] userInfo:nil];
	}
#endif
	id angle_ = [args objectAtIndex:0];
	double angle = [angle_ isEqual:[NSNull null]] ? 0 : [angle_ doubleValue];
	CGAffineTransform result$ = (CGAffineTransform)CGAffineTransformMakeRotation((double) angle);
	return [HyperloopPointer pointer:(const void *)&result$ encoding:@encode(CGAffineTransform)];
}

+(id)CGAffineTransformRotate:(NSArray *)args {
#ifdef TARGET_IPHONE_SIMULATOR
	if ([args count] != 2) {
		@throw [NSException exceptionWithName:@"InvalidArgument" reason:[NSString stringWithFormat:@"CGAffineTransformRotate requires 2 arguments but only %lu passed", (unsigned long)[args count]] userInfo:nil];
	}
#endif
	id t_ = [args objectAtIndex:0];
	CGAffineTransform t = *(CGAffineTransform*)[(HyperloopPointer *)t_ pointerValue];
	id angle_ = [args objectAtIndex:1];
	double angle = [angle_ isEqual:[NSNull null]] ? 0 : [angle_ doubleValue];
	CGAffineTransform result$ = (CGAffineTransform)CGAffineTransformRotate((CGAffineTransform) t, (double) angle);
	return [HyperloopPointer pointer:(const void *)&result$ encoding:@encode(CGAffineTransform)];
}

+(id)CGAffineTransformScale:(NSArray *)args {
#ifdef TARGET_IPHONE_SIMULATOR
	if ([args count] != 3) {
		@throw [NSException exceptionWithName:@"InvalidArgument" reason:[NSString stringWithFormat:@"CGAffineTransformScale requires 3 arguments but only %lu passed", (unsigned long)[args count]] userInfo:nil];
	}
#endif
	id t_ = [args objectAtIndex:0];
	CGAffineTransform t = *(CGAffineTransform*)[(HyperloopPointer *)t_ pointerValue];
	id sx_ = [args objectAtIndex:1];
	double sx = [sx_ isEqual:[NSNull null]] ? 0 : [sx_ doubleValue];
	id sy_ = [args objectAtIndex:2];
	double sy = [sy_ isEqual:[NSNull null]] ? 0 : [sy_ doubleValue];
	CGAffineTransform result$ = (CGAffineTransform)CGAffineTransformScale((CGAffineTransform) t, (double) sx, (double) sy);
	return [HyperloopPointer pointer:(const void *)&result$ encoding:@encode(CGAffineTransform)];
}

+(id)CGContextFillRect:(NSArray *)args {
#ifdef TARGET_IPHONE_SIMULATOR
	if ([args count] != 2) {
		@throw [NSException exceptionWithName:@"InvalidArgument" reason:[NSString stringWithFormat:@"CGContextFillRect requires 2 arguments but only %lu passed", (unsigned long)[args count]] userInfo:nil];
	}
#endif
	id c_ = [args objectAtIndex:0];
	CGContextRef c = *(CGContextRef*)[(HyperloopPointer *)c_ pointerValue];
	id rect_ = [args objectAtIndex:1];
	CGRect rect = *(CGRect*)[(HyperloopPointer *)rect_ pointerValue];
	CGContextFillRect((CGContextRef) c, (CGRect) rect);
	return nil;
}

+(id)CGPointMake:(NSArray *)args {
#ifdef TARGET_IPHONE_SIMULATOR
	if ([args count] != 2) {
		@throw [NSException exceptionWithName:@"InvalidArgument" reason:[NSString stringWithFormat:@"CGPointMake requires 2 arguments but only %lu passed", (unsigned long)[args count]] userInfo:nil];
	}
#endif
	id x_ = [args objectAtIndex:0];
	double x = [x_ isEqual:[NSNull null]] ? 0 : [x_ doubleValue];
	id y_ = [args objectAtIndex:1];
	double y = [y_ isEqual:[NSNull null]] ? 0 : [y_ doubleValue];
	CGPoint result$ = (CGPoint)CGPointMake((double) x, (double) y);
	return [HyperloopPointer pointer:(const void *)&result$ encoding:@encode(CGPoint)];
}

+(id)CGRectMake:(NSArray *)args {
#ifdef TARGET_IPHONE_SIMULATOR
	if ([args count] != 4) {
		@throw [NSException exceptionWithName:@"InvalidArgument" reason:[NSString stringWithFormat:@"CGRectMake requires 4 arguments but only %lu passed", (unsigned long)[args count]] userInfo:nil];
	}
#endif
	id x_ = [args objectAtIndex:0];
	double x = [x_ isEqual:[NSNull null]] ? 0 : [x_ doubleValue];
	id y_ = [args objectAtIndex:1];
	double y = [y_ isEqual:[NSNull null]] ? 0 : [y_ doubleValue];
	id width_ = [args objectAtIndex:2];
	double width = [width_ isEqual:[NSNull null]] ? 0 : [width_ doubleValue];
	id height_ = [args objectAtIndex:3];
	double height = [height_ isEqual:[NSNull null]] ? 0 : [height_ doubleValue];
	CGRect result$ = (CGRect)CGRectMake((double) x, (double) y, (double) width, (double) height);
	return [HyperloopPointer pointer:(const void *)&result$ encoding:@encode(CGRect)];
}

+(id)CGSizeMake:(NSArray *)args {
#ifdef TARGET_IPHONE_SIMULATOR
	if ([args count] != 2) {
		@throw [NSException exceptionWithName:@"InvalidArgument" reason:[NSString stringWithFormat:@"CGSizeMake requires 2 arguments but only %lu passed", (unsigned long)[args count]] userInfo:nil];
	}
#endif
	id width_ = [args objectAtIndex:0];
	double width = [width_ isEqual:[NSNull null]] ? 0 : [width_ doubleValue];
	id height_ = [args objectAtIndex:1];
	double height = [height_ isEqual:[NSNull null]] ? 0 : [height_ doubleValue];
	CGSize result$ = (CGSize)CGSizeMake((double) width, (double) height);
	return [HyperloopPointer pointer:(const void *)&result$ encoding:@encode(CGSize)];
}

+(id)CGAffineTransformIdentity {
	CGAffineTransform result$ = (CGAffineTransform)CGAffineTransformIdentity;
	return [HyperloopPointer pointer:(const void *)&result$ encoding:@encode(CGAffineTransform) framework:@"CoreGraphics" classname:@"CGAffineTransform"];
}

+(id)CGPointZero {
	CGPoint result$ = (CGPoint)CGPointZero;
	return [HyperloopPointer pointer:(const void *)&result$ encoding:@encode(CGPoint) framework:@"CoreGraphics" classname:@"CGGeometry"];
}




@end
