/**
 * HYPERLOOP GENERATED - DO NOT MODIFY
 *
 * This source code is Copyright (c) 2016 by Appcelerator, Inc.
 * All Rights Reserved.  This code contains patents and/or patents pending.
 */
#import <UIKit/UIKit.h>
#import <Foundation/Foundation.h>
#import "TiBase.h"
#import "KrollCallback.h"

@interface HyperloopPointer : NSObject
+(instancetype)pointer:(const void *)pointer encoding:(const char *)encoding;
+(instancetype)pointer:(const void *)pointer encoding:(const char *)encoding framework:(NSString *)framework classname:(NSString *)classname;
-(void *)pointerValue;
-(SEL)selectorValue;
-(Class)classValue;
-(id)objectValue;
@end

@interface HyperloopUtils : NSObject
+(void)invokeCallback:(id)callback args:(NSArray *)args thisObject:(id)thisObject;
@end

@interface HyperloopUIKit : NSObject
@end

@implementation HyperloopUIKit


+(id)UIEdgeInsetsMake:(NSArray *)args {
#ifdef TARGET_IPHONE_SIMULATOR
	if ([args count] != 4) {
		@throw [NSException exceptionWithName:@"InvalidArgument" reason:[NSString stringWithFormat:@"UIEdgeInsetsMake requires 4 arguments but only %lu passed", (unsigned long)[args count]] userInfo:nil];
	}
#endif
	id top_ = [args objectAtIndex:0];
	double top = [top_ isEqual:[NSNull null]] ? 0 : [top_ doubleValue];
	id left_ = [args objectAtIndex:1];
	double left = [left_ isEqual:[NSNull null]] ? 0 : [left_ doubleValue];
	id bottom_ = [args objectAtIndex:2];
	double bottom = [bottom_ isEqual:[NSNull null]] ? 0 : [bottom_ doubleValue];
	id right_ = [args objectAtIndex:3];
	double right = [right_ isEqual:[NSNull null]] ? 0 : [right_ doubleValue];
	UIEdgeInsets result$ = (UIEdgeInsets)UIEdgeInsetsMake((double) top, (double) left, (double) bottom, (double) right);
	return [HyperloopPointer pointer:(const void *)&result$ encoding:@encode(UIEdgeInsets)];
}

+(id)UIGraphicsGetCurrentContext:(NSArray *)args {
#ifdef TARGET_IPHONE_SIMULATOR
	if ([args count] != 0) {
		@throw [NSException exceptionWithName:@"InvalidArgument" reason:[NSString stringWithFormat:@"UIGraphicsGetCurrentContext requires 0 arguments but only %lu passed", (unsigned long)[args count]] userInfo:nil];
	}
#endif
	CGContextRef result$ = (CGContextRef)UIGraphicsGetCurrentContext();
	return (result$ == nil) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(const void *)&result$ encoding:@encode(CGContextRef)];
}

+(id)NSFontAttributeName {
	id result$ = (id)NSFontAttributeName;
	return (result$ == nil || [(id)result$ isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)result$ encoding:@encode(id) framework:@"UIKit" classname:@"NSAttributedString"];
}

+(id)NSShadowAttributeName {
	id result$ = (id)NSShadowAttributeName;
	return (result$ == nil || [(id)result$ isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)result$ encoding:@encode(id) framework:@"UIKit" classname:@"NSAttributedString"];
}

+(id)NSStrokeColorAttributeName {
	id result$ = (id)NSStrokeColorAttributeName;
	return (result$ == nil || [(id)result$ isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)result$ encoding:@encode(id) framework:@"UIKit" classname:@"NSAttributedString"];
}

+(id)NSStrokeWidthAttributeName {
	id result$ = (id)NSStrokeWidthAttributeName;
	return (result$ == nil || [(id)result$ isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)result$ encoding:@encode(id) framework:@"UIKit" classname:@"NSAttributedString"];
}



+ (id) Block_CGVector_____UIFieldBehavior____CGPoint__CGVector__CGFloat__CGFloat__NSTimeInterval_:(KrollCallback *) callback {
	return [^(UIFieldBehavior * arg0, CGPoint arg1, CGVector arg2, CGFloat arg3, CGFloat arg4, NSTimeInterval arg5) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			id _arg1 = [HyperloopPointer pointer:(const void *)&arg1 encoding:@encode(CGPoint)];
			id _arg2 = [HyperloopPointer pointer:(const void *)&arg2 encoding:@encode(CGVector)];
			id _arg3 = [NSNumber numberWithDouble:arg3];
			id _arg4 = [NSNumber numberWithDouble:arg4];
			id _arg5 = [NSNumber numberWithDouble:arg5];
			args = @[_arg0, _arg1, _arg2, _arg3, _arg4, _arg5];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void______:(KrollCallback *) callback {
	return [^{
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____BOOL_:(KrollCallback *) callback {
	return [^(BOOL arg0) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = [NSNumber numberWithBool:arg0];
			args = @[_arg0];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____CGRect__BOOL___:(KrollCallback *) callback {
	return [^(CGRect arg0, BOOL * arg1) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = [HyperloopPointer pointer:(const void *)&arg0 encoding:@encode(CGRect)];
			id _arg1 = (arg1 == nil) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(const void *)&arg1 encoding:@encode(BOOL *)];
			args = @[_arg0, _arg1];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____CGRect__CGRect__NSTextContainer____NSRange__BOOL___:(KrollCallback *) callback {
	return [^(CGRect arg0, CGRect arg1, NSTextContainer * arg2, NSRange arg3, BOOL * arg4) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = [HyperloopPointer pointer:(const void *)&arg0 encoding:@encode(CGRect)];
			id _arg1 = [HyperloopPointer pointer:(const void *)&arg1 encoding:@encode(CGRect)];
			id _arg2 = (arg2 == nil || [(id)arg2 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg2 encoding:@encode(id)];
			id _arg3 = [HyperloopPointer pointer:(const void *)&arg3 encoding:@encode(NSRange)];
			id _arg4 = (arg4 == nil) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(const void *)&arg4 encoding:@encode(BOOL *)];
			args = @[_arg0, _arg1, _arg2, _arg3, _arg4];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____NSArray___:(KrollCallback *) callback {
	return [^(NSArray * arg0) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			args = @[_arg0];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____NSDictionary___:(KrollCallback *) callback {
	return [^(NSDictionary * arg0) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			args = @[_arg0];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____NSString_____Bool_:(KrollCallback *) callback {
	return [^(NSString * arg0, _Bool arg1) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			id _arg1 = [NSNumber numberWithBool:arg1];
			args = @[_arg0, _arg1];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____NSString_____Bool__NSArray____NSError___:(KrollCallback *) callback {
	return [^(NSString * arg0, _Bool arg1, NSArray * arg2, NSError * arg3) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			id _arg1 = [NSNumber numberWithBool:arg1];
			id _arg2 = (arg2 == nil || [(id)arg2 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg2 encoding:@encode(id)];
			id _arg3 = (arg3 == nil || [(id)arg3 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg3 encoding:@encode(id)];
			args = @[_arg0, _arg1, _arg2, _arg3];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____UIAlertAction___:(KrollCallback *) callback {
	return [^(UIAlertAction * arg0) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			args = @[_arg0];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____UIBackgroundFetchResult_:(KrollCallback *) callback {
	return [^(UIBackgroundFetchResult arg0) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = [HyperloopPointer pointer:(const void *)&arg0 encoding:@encode(UIBackgroundFetchResult)];
			args = @[_arg0];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____UILexicon___:(KrollCallback *) callback {
	return [^(UILexicon * arg0) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			args = @[_arg0];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____UIPreviewAction____UIViewController___:(KrollCallback *) callback {
	return [^(UIPreviewAction * arg0, UIViewController * arg1) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			id _arg1 = (arg1 == nil || [(id)arg1 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg1 encoding:@encode(id)];
			args = @[_arg0, _arg1];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____UIPrinterPickerController_____Bool__NSError___:(KrollCallback *) callback {
	return [^(UIPrinterPickerController * arg0, _Bool arg1, NSError * arg2) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			id _arg1 = [NSNumber numberWithBool:arg1];
			id _arg2 = (arg2 == nil || [(id)arg2 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg2 encoding:@encode(id)];
			args = @[_arg0, _arg1, _arg2];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____UITextField___:(KrollCallback *) callback {
	return [^(UITextField * arg0) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			args = @[_arg0];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void______Bool___Bool_:(KrollCallback *) callback {
	return [^(_Bool arg0, _Bool arg1) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = [NSNumber numberWithBool:arg0];
			id _arg1 = [NSNumber numberWithBool:arg1];
			args = @[_arg0, _arg1];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____id_UIPreviewActionItem___UIViewController___:(KrollCallback *) callback {
	return [^(id<UIPreviewActionItem> arg0, UIViewController * arg1) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			id _arg1 = (arg1 == nil || [(id)arg1 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg1 encoding:@encode(id)];
			args = @[_arg0, _arg1];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____id_UIViewControllerTransitionCoordinatorContext__:(KrollCallback *) callback {
	return [^(id<UIViewControllerTransitionCoordinatorContext> arg0) {
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			id _arg0 = (arg0 == nil || [(id)arg0 isEqual:[NSNull null]]) ? (id)[NSNull null] : (id)[HyperloopPointer pointer:(__bridge void *)arg0 encoding:@encode(id)];
			args = @[_arg0];
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}

+ (id) Block_void_____void_:(KrollCallback *) callback {
	return [^{
		void(^Callback)(void) = ^{
			NSArray *args = nil;
			[HyperloopUtils invokeCallback:callback args:nil thisObject:callback];
		};
		if ([NSThread isMainThread]) {
			Callback();
		} else {
			dispatch_async(dispatch_get_main_queue(), Callback);
		}
	} copy];
}


@end
